/*  XMMS - Cross-platform multimedia player
 *  Copyright (C) 1998-2000  Peter Alm, Mikael Alm, Olle Hallnas, Thomas Nilsson and 4Front Technologies
 *  jack driver - Copyright (C) 2002 Chris Morgan<cmorgan@alum.wpi.edu>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef JACK_OUT_H
#define JACK_OUT_H

#include "config.h"

#include <gtk/gtk.h>

#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/time.h>

#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <xmms/plugin.h>
#include <xmms/configfile.h>

typedef struct
{
  gint buffer_size;
  gint prebuffer;
} jackconfig;

extern OutputPlugin op;
extern jackconfig jack_cfg;


void jack_init(void);
void jack_about(void);
void jack_configure(void);

void jack_get_volume(int *l, int *r);
void jack_set_volume(int l, int r);

int jack_playing(void);
int jack_free(void);
void jack_write(void *ptr, int length);
void jack_close(void);
void jack_flush(int time);
void jack_pause(short p);
int jack_open(AFormat fmt, int sample_rate, int num_channels);
int jack_get_output_time(void);
int jack_get_written_time(void);
void jack_set_audio_params(void);

#endif
